function binned = bintags(tagdata, dir,  chrominfo, ChromMap, wsize)
taglength = 200 ;
totalbins = max(chrominfo(:, 4)) ;
totalbins 
fracs =  wsize/taglength ;
binned = zeros([totalbins, 1])  ;
[csize ccol] = size(ChromMap) ;

[ chromcount cols ] = size(chrominfo) ;
if ((dir == 1) || (dir == -1))

j = 0 ;
mat= [] ;


for chrm = 1:chromcount
    chr = ChromMap(chrm,1) ;
postg = find((tagdata(:, 1) == chrm ) & (tagdata(:, 3) == dir ) & (tagdata(:, 2) > chrominfo(chr, 3) ) & (tagdata(:, 2) < chrominfo(chr, 5))) ;
    ctagpos = chrominfo(chr, 2) + ceil((tagdata(postg, 2) - chrominfo(chr, 3)) / wsize)  ;
   
    [trows tcols] = size(postg) ;
    
    for i = 1:trows
         binned(ctagpos(i), 1) = binned(ctagpos(i), 1) + 1 ;
    end
end
clear ctagpos postg ;

else

    
    if(dir == 2)
    
    [ro col] = size(tagdata) ;
    addloc = ceil(taglength/wsize) ;
  for i = 1:ro
    chrname = tagdata(i , 1) ;
    if(chrname <= csize )
    
     chr = ChromMap(chrname,1) ;
    
    if(dir == 1)
    ploc1 = tagdata(i , 2)  ;
    ploc2 = tagdata(i, 2) + taglength ;
    else
    ploc1 = tagdata(i , 2) - taglength ;
    ploc2 = tagdata(i, 2)  ;   
    end
    
   chrloc1 = chrominfo(chr, 2) + ceil((ploc1 - chrominfo(chr, 3)) / wsize)  ;
   chrloc2 = chrloc1 + addloc ;
     % [chr i chrloc1]
    if((chrloc1  > chrominfo(chr, 2) ) & (chrloc1 < chrominfo(chr, 4) ))     
    if((chrloc2  > chrominfo(chr, 2) ) & (chrloc2 < chrominfo(chr, 4) ))     
        binned(chrloc1:chrloc2, 1) = binned(chrloc1:chrloc2, 1) + fracs ;
    end
    end    
 end
 
 
  end
    end
    %%%%%%%%%%%%%%%%%%%%% for paired end  reads %%%%
    if(dir == 3)
    for chrm = 1:chromcount
    chr = ChromMap(chrm,1) ;
postg = find((tagdata(:, 1) == chrm ) & (tagdata(:, 2) > chrominfo(chr, 3) ) & (tagdata(:, 2) < chrominfo(chr, 5))) ;
    ctagpos = chrominfo(chr, 2) + ceil(( 0.5*(tagdata(postg, 2)+tagdata(postg, 3))  - chrominfo(chr, 3)) / wsize)  ;
   
    [trows tcols] = size(postg) ;
    
    for i = 1:trows
         binned(ctagpos(i), 1) = binned(ctagpos(i), 1) + 1 ;
    end
end
    
    end
    
     %%%%%%%%%%%%%%%%%%%%% bedGraph file %%%%
    if(dir == 10)
    for chrm = 1:chromcount
    chr = ChromMap(chrm,1) ;
postg = find((tagdata(:, 1) == chrm ) & (tagdata(:, 2) > chrominfo(chr, 3) ) & (tagdata(:, 2) < chrominfo(chr, 5))) ;
    ctagpos = chrominfo(chr, 2) + ceil((tagdata(postg, 2)  - chrominfo(chr, 3)) / wsize)  ;
   
    [trows tcols] = size(postg) ;
    
    for i = 1:trows
         binned(ctagpos(i), 1) = binned(ctagpos(i), 1) + tagdata(postg(i), 3) ;
    end
end
    end      
    
    
end











