
FORMAT = 1 ;
PAIREDEND = 0 ;
REDUND = 1 ;
vartrack = zeros(5 ,1) ;
ChIPnum = [] ;
INPUTfiles = {} ; 
NOcorrect = 0 ;

for i = 1:optargin
checkt = textscan( cargs{i} , '%s' , 'delimiter' , '=') ;
  
if (strcmp( checkt{1}{1} , '-d' ) == 1)
  vals = textscan( checkt{1}{2}, '%s' , 'delimiter' , ',' ) ;  
    CHIPfiles = vals{1} 
    vartrack(1) = 1 ;
end

if (strcmp( checkt{1}{1} , '-c' ) == 1)
    vals = textscan( checkt{1}{2}, '%s' , 'delimiter' , ',' )  ;
    INPUTfiles = vals{1} 
    vartrack(2) = 1 ;
end

% if (strcmp( checkt{1}{1} , '-seq' ) == 1)
%     vals = textscan( checkt{1}{2}, '%d' , 'delimiter' , ',' )  ;
%     ChIPnum = vals{1} 
%     vartrack(3) = 1 ;
% end


if ( strcmp( checkt{1}{1} , '-nocorr' ) == 1) 
    NOcorrect = 1 ;
end


if (strcmp( checkt{1}{1} , '-o' ) == 1)
    outfile =   checkt{1}{2} ;
    vartrack(4) = 1 ;
end


if (strcmp( checkt{1}{1} , '-f' ) == 1)
    if( (strcmp(checkt{1}{2} , 'BAM') == 1) | (strcmp(checkt{1}{2} , 'SAM') == 1)  )  
    FORMAT = 2 ;
    end
     if( (strcmp(checkt{1}{2} , 'bam') == 1) | (strcmp(checkt{1}{2} , 'sam') == 1)  )
     FORMAT = 2 ;
     end    
    if( (strcmp(checkt{1}{2} , 'bedgraph') == 1) |(strcmp(checkt{1}{2} , 'bedGraph') == 1)) 
    FORMAT = 3;
    end
end



if (strcmp( checkt{1}{1} , '-g' ) == 1)
    geneFile =  checkt{1}{2} ;
       vartrack(5) = 1 ;
end



if (strcmp( checkt{1}{1} , '-m' ) == 1)
    matrixFile =  checkt{1}{2} ;
       vartrack(6) = 1 ;
end


end

% 
% if(Auto == 1)
% Type = 'any' ;                            % For Transcription fractor CHiPseq use Type = 'any'
% else
% PositiveBed = 'Prompos1.bed'  % change it to the bed file name which contains postives locations
% end
% 
% if(Auton == 0)
% NegativeBed = 'negatives.bed' 
% end




disptext = { 
'-d=ChIPfiles   filenames of sample, more than one filename can be given. The input file'
'                   containing tags from high throughput sequencing. (compulsory)'
'           '
'-c=INPUTfiles   filenames of control input tags, more than one filename is given.'
'                if more than one input control file is given then it should be equal to number of sample filename. (optional)\n'
'             '
'-f=bam /sam/ bed format of the input tag file it can be bam , bed or sam file. '
'                   The default is 6 column bed format   '
'         '
'-g=geneFile the downloaded geneFile (compulsory)'

'            '
'-m=matrixFile the downloaded matrixFile (compulsory)'
'          '
'-o=output output file (compulsory)'

'-nocorr    This option is used when no correction is done for gene specific biases  '
'              it will reduce correlation with actual expression but increase correlation with motif occurances'
} ;





if( sum(vartrack) < 5 )
fprintf('%s\n', disptext{:}) ;
end

if(vartrack(1) == 0 )
   errors = 'No sample data file given    exiting ' 
   
  exit(1) ; 
end

% if(vartrack(3) == 0 )
%    errors = 'The sequence of ChIPseq not given'
%     
% end

if(vartrack(4) == 0 )
   errors = 'No output file  \n'  
   exit(1) ; 
end


if(vartrack(5) == 0 )
   errors = 'Genefile not given download the gene file and provide iwth option -g  \n'  
   exit(1) ; 
end

if(vartrack(6) == 0 )
   errors = 'Precalculated matrix file not given download the matrix file \n'  
   exit(1) ; 
end













