function ppos = pickregions(data, mode, binsize, TSS, Ksize)

K1gap = ceil(1000/binsize) ;
[drows dcols] = size(data) ;
ppos = [] ;

if (mode == 1) % picks negative regions
ppos= [] ; count = 0 ;
K1gap =  Ksize   ;
meanwin = ones([2*Ksize+1, 1]) / (2*Ksize +1) ;

data = convn(data, meanwin, 'same') ;
me = prctile(data, 98) ;

if(me == 0)
   me = prctile(data, 99) ;     
end
pos = find((data < me) & (data > (0.2*me))) ;
if(me == 0)
me = 2 ;
pos = find((data < me) & (data > (0.2*me))) ;
end


[prows pcols] = size(pos) ;

 RandStream.setGlobalStream(RandStream('mt19937ar','seed',sum(100)));   
 randp = ceil((prows - 100)  *rand([2000,1]) ) ;
 
 ppos = pos(randp) ;
 %%%%%%%%%%%%%%%  previuos code %%%%%%%%%%%%%%
%count = 0 ;
%marginst = 2*K1gap + 1 ;


% for iter = 1:10
%  RandStream.setDefaultStream(RandStream('mt19937ar','seed',sum(100*iter)));   
% randp = ceil(drows  *rand([20000,1]) ) ;
%    
% for j = 1:20000
% 
% if((randp(j) > marginst) & (randp(j) < (drows- marginst)) )
%     lmean = mean(data(randp(j)-K1gap : randp(j)+K1gap) ) ;
%     if((lmean < me) & (lmean > 0.01 *me ))
%     count = count + 1;
%     ppos(count, 1) = randp(j) ;
%     end
%     
% end
% 
% end
% 
% if(count > 1000)
% break 
% end
% end
    

end



if(mode == 2)  %%%% picks top 500 from positives with high signal 
    
   [grows gcols ] = size(TSS) ;
   avgTSS = zeros(grows , 1) ;
   ulimit = drows - K1gap ;
   for i = 3:grows-2
       if((TSS(i, 1) > K1gap) & (TSS(i, 2) < ulimit)) 
   avgTSS(i,1) = mean(data((TSS(i, 1) - K1gap) :(TSS(i, 2) + K1gap) ,1 )) ;
  
   end
   end
    
   [B idx] = sort(avgTSS, 'descend') ;
   if(numel(idx) > 500)
   ppos = [ TSS(idx(1:500), 1) TSS(idx(1:500), 1) ] ;
   else
     ppos = [ TSS(idx(1:20), 1) TSS(idx(1:20), 1) ] ;  
   end
end




if(mode == 3) %%%% picks top 500 nonTSS with high signal 
   meanwin =  ones([K1gap, 1]) ; meanwin = meanwin / sum(meanwin) ;
   
   for i = 1:grows
    data( (TSS(i) -2*K1gap) : (TSS(i, 1) + 2*K1gap) ) = 0 ;
   end
   data = convn(data, meanwin, 'same') ; 
   thr = mean(data) + 4*std(data) ;
 
   lpos = find(data > thr) ;
   
   [luci newmods] = filterpeaks(data(lpos) , lpos, binsize) ;
   [B idx] = sort( newmods, 'descend') ;
   if(numel(idx) >500)
   ppos = [ lpos(luci(idx(1:500), 1))  lpos(luci(idx(1:500), 1)) ] ;
   else
     ppos = [ lpos(luci(idx(1:20), 1))  lpos(luci(idx(1:20), 1)) ] ;  
   end
end


if(mode == 4) %%%% picks top 500 regions with high signal 
   meanwin =  ones([K1gap, 1]) ; meanwin = meanwin / sum(meanwin) ;
   
   data = convn(data, meanwin, 'same') ; 
   thr = mean(data) + 2*std(data) ;
   lpos = find(data > thr) ;
   [luci newmods] = filterpeaks(data(lpos, 1) , lpos, binsize) ;
   [B idx] = sort( newmods, 'descend') ;
   [iro icol] = size(idx) ;  
   if(iro > 1000)
       iro = ceil(0.05 *iro) ;
   ppos = [ (lpos(luci(idx(iro:iro+1000), 1))-1)  (lpos(luci(idx(iro:iro+1000), 2))+1) ] ;
   else
        iro1 = ceil(0.05 *iro) ;
     ppos = [ (lpos(luci(idx(iro1:iro), 1))-1)  (lpos(luci(idx(iro1:iro), 2))+1) ] ;   
   end
   
end









