function [ tagsPos tagsNeg] = tagto2D( tmpdata , peaks , chrominfo , chromMap, binsize, bingap, typin )
shift = ceil(200 /(2*binsize)) ;
[ro col] = size(tmpdata) ;
[ prows pcols ] = size(peaks) ;
[csize cols] = size( chrominfo) ;
bingap2 = 2*bingap ;

tagsPos = zeros(prows, bingap2 ) ;
tagsNeg = zeros(prows, bingap2 ) ;

bingap2 = bingap2 - shift ;

for i = 1:ro
    chrname = tmpdata(i , 1) ;   
if((chrname <= csize ) & (chrname > 0 ))
    chr = chromMap(chrname,1) ;
    ploc1 = tmpdata(i , 2) ; 
    
     chrloc1 = chrominfo(chr, 2) + ceil((ploc1 - chrominfo(chr, 3)) / binsize)  ;    
    tmpdata(i, 2) = chrloc1 ;
    tmpdata(i, 1) = chr ;
end

end


prvchr = 0 ;
for i = 1:prows
    chrname = peaks(i, 1) ;   

  if((chrname <= csize ) & (chrname > 0 ))
    chr = chromMap(chrname,1) ;
    ploc1 = peaks(i , 5) ;
  
     chrloc1 = chrominfo(chr, 2) + ceil((ploc1 - chrominfo(chr, 3)) / binsize) - bingap ;

if(prvchr == chr)  
    pos1 = find( ((tmpdata(posch, 2) - chrloc1) <  bingap2) & ((tmpdata(posch, 2) - chrloc1) > shift) ) ;
posp = posch(pos1) ;
else
posch = find(tmpdata(:, 1) == chr) ;
 pos1 = find( ((tmpdata(posch, 2) - chrloc1) <  bingap2) & ((tmpdata(posch, 2) - chrloc1) > shift) ) ;
posp = posch(pos1) ;
prvchr = chr ;
end

[ppro cols ] = size(posp) ;

       if(typin == 0) 
        for j = 1:ppro
            dloc = tmpdata(posp(j), 2) - chrloc1  ;
        if(tmpdata(posp(j), 3) == 1 )     
          tagsPos(i , dloc ) = tagsPos(i , dloc ) + 1 ;  
        else
          tagsNeg(i , dloc ) = tagsNeg(i , dloc ) + 1 ;       
        end
        
        end
       else 
            for j = 1:ppro
          dloc = tmpdata(posp(j), 2) - chrloc1 ; 
        if(tmpdata(posp(j), 3) == 1 )     
          tagsPos(i , dloc:dloc+shift ) = tagsPos(i , dloc:dloc+shift ) + 1 ;  
        else
          tagsNeg(i ,dloc-shift:dloc ) = tagsNeg(i , dloc-shift:dloc ) + 1 ;       
        end
            end          
       end

       
end

end
end




