function dfilter( varargin ) 

cargs = varargin ;
optargin = size(varargin,2);
parseargs ;

[OUTFILEpath, OUTFILEname, OUTFILEext] = fileparts(OUTPUTfile) ;
if( strcmp(OUTFILEpath, '') == 1)
    OUTFILEpath = './' 
end

pause( ceil(5*rand(1,1)) );
    
RandStream.setGlobalStream(RandStream('mt19937ar','seed',sum(100*clock)));


for  i = 1:100
    runID = ceil(100000*rand(1,1) ) + feature('getpid') ;
    if (exist( ['genome-limits' num2str(runID)] , 'file') == 2 )
        [i runID]
    els
    break ;    
    end
end


 command = sprintf('findlimits  %s genome-limits%d %d' ,CHIPfiles{1} , runID, FORMAT ) ;
 system(command) ;
 [actualChr actualLow actualHigh] = textread(['genome-limits' num2str(runID) ] , '%s %d %d') ;

[chromcount cols] = size(actualLow) ;
genomeinfo(:, 1) = (1:chromcount)' ;

genomeinfo(:, 2) = actualLow;
genomeinfo(:, 3) = actualHigh;

[chromcount cols] = size(genomeinfo) ;
locs = 0 ;
k1gap = ceil(1000/binsize) ;
Ksize = ceil(Ksize/2) ;
knownTSS = [] ;

 shift = floor(taglength / (2*binsize)) ;

 %%%%%  arrange chromsomes binning and limits info %%%%%%%%%%%%%%%%
chromMap = [] ; locs = 0 ;
for i =1:chromcount
chrominfo(i, 1) = genomeinfo(i, 1) ;
chromMap(genomeinfo(i, 1), 1) = i ;
chrominfo(i, 2) = locs + 1 ;
chrominfo(i, 3) = genomeinfo(i, 2) ;
locs = locs + floor(( genomeinfo(i, 3) - genomeinfo(i, 2)) / binsize) ;
chrominfo(i, 4) = locs ; 
chrominfo(i, 5) = genomeinfo(i, 3) ;
end
chrominfo(chromcount, 4) = chrominfo(chromcount, 4) + 1 ;
 
chrominfo = ceil(chrominfo) ;
totalbins = chrominfo(chromcount, 4) ;
%%%%%%%%%%% load control %%%%%%%%%%%%%%%%%%%

[ro Icols] = size(INPUTfiles) ;

% if(Icols == 1)
%   command = sprintf('tag2mat  %s tmp.txt%d genome-limits%d %d %d' ,INPUTfiles{1}, runID, runID, FORMAT, PAIREDEND ) ;
%   system(command) ;
%   tmpdata = loadtags(['tmp.txt' num2str(runID)], REDUND, genomeinfo(:, 1), PAIREDEND) ;
%   data = bintags(tmpdata, 2 , chrominfo, chromMap, binsize) ;
%   meanwin = ones([k1gap 1 ]) ; meanwin  = meanwin / sum(meanwin) ;
%   controldataf = findtagdensity(data, binsize) ;
% controldataf = controldataf / (mean(data) + 0.1) ;
%   clear data tmpdata ;
%   
% end

  

%%%%%%%%%%% load positives %%%%%%%%%%%%%%%%%%%

if(Auto == 0)
bedlocs = loadbed(PositiveBed) ;
GivenPos = bin2mat( bedlocs, chrominfo, chromMap, binsize) ;
end

[ marks ro] = size(CHIPfiles) 
 
 collection = {} ; cprofiles = {} ;
posdata = zeros([totalbins 1]) ; 

for i = 1:marks
    
    [INFILEpath, INFILEname, INFILEext] = fileparts(CHIPfiles{i}) ;
    
     command = sprintf('tag2mat  %s tmp.txt%d genome-limits%d %d %d' ,CHIPfiles{i}, runID, runID, FORMAT, PAIREDEND ) ;
system(command) ;
tmpdata = loadtags( ['tmp.txt' num2str(runID)], REDUND, genomeinfo(:, 1), PAIREDEND, FORMAT) ;
tmpdata = ceil(tmpdata) ;

if (PAIREDEND == 0)

tposdata = bintags(tmpdata, 1 , chrominfo, chromMap, binsize) ;
tnegdata = bintags(tmpdata, -1, chrominfo, chromMap, binsize) ; 

clear tmpdata ;

if((i == 1) & (SHIFT == 0))
taglength = findshift(tposdata(:, i), tnegdata(:, i) , binsize ) ;
shift = floor(taglength / (2*binsize)) 
end

posdata((shift+1):(totalbins-shift), i) = tposdata(1:(totalbins - 2*shift))  + tnegdata(2*shift+1 : totalbins)  ;
else
    if(FORMAT == 3)
        posdata(:, i) = bintags(tmpdata, 10 , chrominfo, chromMap, binsize) ;
    else
        posdata(:, i) = bintags(tmpdata, 3 , chrominfo, chromMap, binsize) ;
    end
end

clear tposdata tnegdata;

if(((i == 1) & (Icols > 0))| (Icols > 1)) 
    if (strcmp(INPUTfiles{i}, ':') == 0)    
         command = sprintf('tag2mat  %s tmp.txt%d genome-limits%d %d %d' ,INPUTfiles{i}, runID, runID, FORMAT, PAIREDEND ) ;
  system(command) ;
  tmpdata = loadtags(['tmp.txt' num2str(runID)], REDUND , genomeinfo(:, 1), PAIREDEND, FORMAT) ;
  if(FORMAT == 3)
  data = bintags(tmpdata, 10 , chrominfo, chromMap, binsize) ;
  else
  data = bintags(tmpdata, 2 , chrominfo, chromMap, binsize) ;
  end
  
  controldataf = findtagdensity(data, binsize) ;
controldataf = controldataf / (mean(data) + 0.1) ;
  clear data tmpdata ;
    else
        controldataf(:) = 0.2 ;
end
end

if(wigMode == 1) 
writeWig(posdata(:, i), [ OUTFILEpath '/' INFILEname  INFILEext  ] , binsize, chrominfo, actualChr) ;
end


if(Icols > 0)
   posdata(:, i) = posdata(:, i) ./ (controldataf  + 0.5);
end
    
me = mean(posdata(:, i)) ; stdn = std(posdata(:,i)) ;
 posdata(:,i) = posdata(:, i) /(me + 0.01) ;


if(NwigMode == 1)
 writeWig(posdata(:, i), [ OUTFILEpath '/normalised-'  INFILEname  INFILEext  ], binsize, chrominfo, actualChr) ;
end
   
if((Auton ==1) & (i ==1)) 
    pos = find(abs(posdata) == 0) ;
    if(numel(pos) > (95 * totalbins)) 
 posdata(pos) = 0.50 * rand(size(pos)) ;       
    end
posn = pickregions(posdata(:, i), 1, binsize, knownTSS, Ksize) ;
end


% prc98 = prctile(posdata(:, i), 98) ;  prcpos = find(posdata(:, i) < prc98) ;
 
if((Auto == 1) & (i ==1))
    poslocs = pickregions(posdata(:, i), 4, binsize, knownTSS, Ksize) ;    
end

if( (Auto== 0) & (i == 1) )
   if ( selectPos > -1)
    poslocs = pickregions(posdata(:, i), 2, binsize, GivenPos, Ksize)  ;
    else
    poslocs = GivenPos ;    
    end
end

Ksize 

if ((autowidth == 1)& (i== 1))
learnKernelWidth
Ksize
end


 [crow, ccols] = size(poslocs)  ;
 lcollect = zeros([crow 2*Ksize+1 ]) ;
 
 sumav = zeros([2*Ksize+1, 1]) ;
 nsumav = zeros([2*Ksize+1, 1]) ;

 for j = 1:crow
      loci = ceil((poslocs(j, 1) + poslocs(j, 2))/2) ;    
      if ((loci > Ksize) & (loci < (totalbins - Ksize) ) )   
      sumav = sumav + posdata(loci - Ksize: loci + Ksize,i) ;
      lcollect(j,:) = (posdata(loci - Ksize: loci + Ksize,i)  )' ;
      end
 end
 
  [ncrow, ccols] = size(posn)  ;
 lcollectn = zeros([crow 2*Ksize+1 ]) ;
  for j = 1:ncrow
  nloci = posn(j) ;
 if ((nloci > Ksize) & (nloci < (totalbins - Ksize) ) )   
  lcollectn(j,:) = (posdata(nloci - Ksize: nloci + Ksize,i) )' ;
   nsumav = nsumav + posdata(nloci - Ksize: nloci + Ksize,i)  ;
  end
  end
  
 collection{i} = lcollect ;
 
 ncollection{i} = lcollectn ;
 
end
clear controldataf ;

 combobj =[] ;
 comprofile = [] ;
 
 for i = 1:marks 
     if (i == 1)
 combobj = collection{1} ;
 comprofile = mean(combobj) ;
 
 ncombobj = ncollection{1} ;
 ncomprofile = mean(ncombobj) ;
     else
  lcollect = collection{i} ; 
  lprof = mean(lcollect) ;
  
  lcollectn = ncollection{i} ; 
  lprofn = mean(lcollectn) ;
  
  combobj = [combobj lcollect] ;
  comprofile = [comprofile  lprof] ;
  
  ncombobj = [ncombobj lcollectn] ;
  ncomprofile = [ncomprofile  lprofn] ;
     end
  
 end



covar =   (combobj' * combobj / crow)  - comprofile' * comprofile ;
covar1 =  (ncombobj' * ncombobj / ncrow)  - ncomprofile' * ncomprofile ;
[crow, ccols] = size(poslocs)  ;
 invcov = optimiseCov(covar + covar1, 2 ,crow ) ;
comkernel = inv(invcov) * (comprofile - ncomprofile)' ;

%%%%%%%% for checking profiles %%%%%%%
%   cov2save = (covar + covar1)/2 ;  
%  save('covar', 'covar' , '-ascii') ;
%   save('covar1' , 'covar1' , '-ascii') ;
%     save('cov2save' , 'cov2save' , '-ascii') ;
%   save('comprofile' , 'comprofile' , '-ascii' ) ;
%   save('ncomprofile' , 'ncomprofile' , '-ascii' ) ;
%  save('invcov1' , 'invcov' , '-ascii') ;
% 
%  
 
 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

combscore = zeros([totalbins, 1]) ;
comkernel = comkernel - min(comkernel) ; 
comkernel = comkernel / max(comkernel) ;

save('comkernel', 'comkernel' , '-ascii') ;
clear lkernel flkernel tmpdata ;

for i = 1:marks
lkernel(:, 1) = comkernel((i-1)*(2*Ksize +1) + 1: i* (2*Ksize +1) ) ;

if(TFmode == 0)
lkernel = lkernel - mean(lkernel) ;
end

for j = 1:(2*Ksize +1)
    flkernel(j, 1) = lkernel(2*Ksize + 2 - j , 1) ;
end

if(direction == 0)
lkernel = (flkernel + lkernel)/2.0 ;
end

poscore(:, 1) = convn( posdata(:, i) , lkernel , 'same' ) ;

if(direction == 1)
  poscore(:, 2) = convn(posdata(:, i) , flkernel , 'same' ) ;
combscore = combscore + max(poscore, [],2)  ;
else
    combscore = combscore + poscore ;
end
clear poscore ;
end


 if(wigMode == 1)
     
writeWig(combscore, OUTPUTfile , binsize, chrominfo, actualChr ) ;

 end
 
 
  %%%%%%%%  decide the threshold for peak detection %%%% 
  
    %%%%%%%%  decide the threshold for peak detection %%%% 
  
    
 hislimit1 = prctile(abs(combscore), 99.5 );
 
  %%% since in TFmode kernel width is less there is chance of lot of 
  %%% bins with very low value and over-estimation of significance
  
  if(TFmode == 1)
 hislimit2 = 0.5*max([ mean(abs(combscore)) std(abs(combscore))  ]) 
  else
   hislimit2 = 0.5*min([ mean(abs(combscore)) std(abs(combscore))  ])    
  end
  
  pos = find((abs(combscore) > hislimit2) & (abs(combscore) <  hislimit1 )  ) ;
  
  if(numel(pos) == 0) ;
  pos = find(abs(combscore) > 0 ) ;
  end
      
  
if (TFmode == 1)
    [Nhi Xhis ] = hist(combscore(pos), 500) ; 
Nhi = [Nhi Nhi] ;
Xhis = [-Xhis Xhis] ;
 [hi idx] = sort(Xhis) ;
 Xhis = Xhis(idx) ; Nhi = Nhi(idx) ;
else
    [Nhi Xhis ] = hist(combscore(pos), 1000) ; 
end

Nhi = Nhi/ sum(Nhi) ;
 Nmax = max(Nhi) 


   if(TFmode == 1)
     pos = find( Nhi > (Nmax * 0.02) ) ; 
   else
   pos = find(  Nhi > (Nmax*0.05) ) ;
   end

% [trpos trco] =size(pos) ;



gpara=polyfit(Xhis(pos),log(Nhi(pos)),2);
gsigma=sqrt(-1/(2*gpara(1)));
gmu=gpara(2)*gsigma^2;
A=exp(gpara(3)+(gmu^2)/(2*gsigma^2));

histd = [Nhi;  Xhis ] ;

%save('histd', 'histd', '-ascii') ;
%save([CHIPfiles{1} '-combscore'] , 'combscore' , '-ascii' ) ;
%save('posscore', 'poscore', '-ascii' ) ;  

gsigma 
gmu
A


  
if (TFmode == 1)
    [Nhi Xhis ] = hist(combscore, 500) ; 
Nhi = [Nhi Nhi] ;
Xhis = [-Xhis Xhis] ;
 [hi idx] = sort(Xhis) ;
 Xhis = Xhis(idx) ; Nhi = Nhi(idx) ;
else
    [Nhi Xhis ] = hist(combscore, 1000) ; 
end

Nhia = normcdf(-abs(Xhis), gmu, gsigma );
FDRest = zeros(1000, 2) ;
for i = 1:1000
FDRest(i, 1) = Xhis(i) ;
%[trpos trcol] = size( find(combscore >= Xhis(i)));
FDRest(i, 2) = 100*Nhia(i)/ sum(Nhi(i:1000)) ;
end
%FDRest'


clear hislimit1 hislimit2 Nmax Nhi Xhis ;

  
  %%%%%%%%%%%%% detect peaks and save %%%%%%%%%%%%%%%%%%%
 
  PeakThresh = gmu + mFoldSt *gsigma ;
  psize = ceil(1000 / ( peakmerge /  binsize)) ;
  PeakThresh

 pos = find(combscore > PeakThresh) ;
 [luci newmods] = filterpeaks( combscore(pos,:) , pos, psize) ;
 
 
 
 [lrows, lcols] = size(luci) ;
peaks = zeros([lrows ,5]) ;

for i =1:lrows
    ploc1 = pos(luci(i, 1)) ;  ploc2 = pos(luci(i, 2)) ; 
[maxl mpos] = max( combscore(ploc1:ploc2) ) ; plocm = ploc1 + mpos - 1 ;
   maxtags = ceil(mean( posdata(ploc1:ploc2, 1) )) ; 
    chr = find(( chrominfo(:, 2) <= ploc1) & (  chrominfo(:, 4) >= ploc1 ) ) ; 
       chrloc1 = chrominfo(chr, 3) + (ploc1 - chrominfo(chr, 2)) * binsize ;
       if(ploc2 == ploc1)
      chrloc2 = chrloc1 + binsize ; chrlocm = chrloc1 ;
       else
       chrloc2 = chrominfo(chr, 3) + (ploc2 - chrominfo(chr, 2)) * binsize ;
       chrlocm = chrominfo(chr, 3) + (plocm - chrominfo(chr, 2)) * binsize ;
       end
       
       if( (truncateWidePeaks  > 1000) & ((chrloc2 - chrloc1) > truncateWidePeaks ))
    peaks(i, 1) = chrominfo(chr, 1) ;
    peaks(i, 2) = ceil(chrlocm - truncateWidePeaks/2) ;
    peaks(i, 3) =  ceil(chrlocm + truncateWidePeaks/2) ;
    peaks(i, 4) = newmods(i,1) ; 
    peaks(i, 5) = chrlocm ;
    peaks(i, 7) = maxtags ;
       else
    peaks(i, 1) = chrominfo(chr, 1) ;
    peaks(i, 2) = chrloc1 ;
    peaks(i, 3) = chrloc2 ;
    peaks(i, 4) = newmods(i,1) ; 
    peaks(i, 5) = chrlocm ;
    peaks(i, 7) = maxtags ;
       end
       post = find(peaks(i, 4) > FDRest(:, 1)) ;
       peaks(i, 8) = min(FDRest(post, 2)) ;
end 


peaks(:, 6) =   -log10( normcdf(-abs(peaks(:, 4)), gmu, gsigma ) + 1E-200) ;
peaks(:, 4) = 5* peaks(:,4) ;


pos = find(peaks(:, 6) >= LPVAL) ;
peaks = peaks(pos,:) ;

instr= 'chromosome  peak-start  peak-end maxScore   peak-center     -log10(P-value)     Norm-tag-count   FDR(%)' ;
writebedNew(peaks, OUTPUTfile, actualChr, instr) ;

if (RefineMode == 0)
peaktrackfile = [OUTFILEpath '/track-' OUTFILEname '.bed' ]
instr= ['track name="DFilter-peaks' OUTFILEname '"' ] ;
writebedNew(peaks(:, 1:4), peaktrackfile, actualChr, instr ) ;
end


 clear flkernel data  lkernel lcollectn  lcollect lambdad k1gap tmpdata trows  
 clear ncollection ncombobj  newmods nloci nlme  noiseme controldataf ;
 clear  collection  combobj lcols   luci  meanwin  nsumav 

clear posdata combscore ;

if((RefineMode ==1 ) & (FORMAT < 3))
refine1( CHIPfiles, {} , peaks  ,OUTPUTfile , 5 , runID, FORMAT, PAIREDEND) ;
end

command = sprintf('rm  tmp.txt%d genome-limits%d' , runID, runID ) ;
system(command) ;








