function efilterpredict( varargin )

cargs = varargin ;
optargin = size(varargin,2);
parseargsE ;

wsize = 200 ;
binsize = wsize ;

RandStream.setGlobalStream(RandStream('mt19937ar','seed',sum(100*clock)));

 runID = ceil(100000*rand(1,1) ) + feature('getpid') ;

 command = sprintf('findlimits  %s genome-limits%d %d' , CHIPfiles{1} , runID, FORMAT ) ;
 system(command) ;
[actualChr actualLow actualHigh] = textread(['genome-limits' num2str(runID) ] , '%s %d %d') ;

[chromcount cols] = size(actualLow) ;

genomeinfo(:, 1) = (1:chromcount)' ;
genomeinfo(:, 2) = actualLow;
genomeinfo(:, 3) = actualHigh;

[chromcount cols] = size(genomeinfo) ;


 %%%%%  arrange chromsomes binning and limits info %%%%%%%%%%%%%%%%
chromMap = [] ; locs = 0 ;
for i =1:chromcount
chrominfo(i, 1) = genomeinfo(i, 1) ;
chromMap(genomeinfo(i, 1), 1) = i ;
chrominfo(i, 2) = locs + 1 ;
chrominfo(i, 3) = genomeinfo(i, 2) ;
locs = locs + ( genomeinfo(i, 3) - genomeinfo(i, 2)) / binsize ;
chrominfo(i, 4) = locs ; 
chrominfo(i, 5) = genomeinfo(i, 3) ;
end

 
chrominfo = ceil(chrominfo) ;
totalbins = chrominfo(chromcount, 4) ;

[crows ccols] = size(CHIPfiles) 
crows = crows * ccols ;

[ NMlist chrom sign cdst cdend gname  ] = textread(geneFile , '%s\t%s\t%d\t%d\t%d\t%s') ;

[grows gcols] = size(cdst) ;
genedata = zeros(grows, 4) ;

for i = 1:grows
    
    for j = 1:chromcount
    if( strcmp( chrom{i} , actualChr{j} ))
    chr1 = j ;
    break ;
    end
    end
   
genedata(i , 1) = chr1 ; genedata(i, 2) = cdst(i) ; genedata(i, 3) = cdend(i) ;
genedata(i, 4) = sign(i) ;
% if(strcmp(sign{i}, '+'))
% genedata(i, 4) = 1 ;
% else
%     genedata(i, 4) = -1 ;
% end

end

prommat = bin2mat(genedata(:, 1:3) ,  chrominfo, chromMap, wsize) ;


[ro Icols] = size(INPUTfiles) ;

if(Icols == 1)
  command =  sprintf('tag2mat  %s tmp.txt%d genome-limits%d %d %d' ,CHIPfiles{i}, runID, runID, FORMAT, PAIREDEND ) ;
  system(command) ;
  tmpdata = loadtags( ['tmp.txt' num2str(runID)], REDUND, genomeinfo(:, 1), PAIREDEND, FORMAT) ;
 if(FORMAT == 3)
  data = bintags(tmpdata, 10 , chrominfo, chromMap, binsize) ;
  else
  data = bintags(tmpdata, 2 , chrominfo, chromMap, binsize) ;
  end
  controldataf = findtagdensity(data, binsize) ;

  clear data tmpdata ;
  
end




for i = 1:crows
command =  sprintf('tag2mat  %s tmp.txt%d genome-limits%d %d %d' ,CHIPfiles{i}, runID, runID, FORMAT, PAIREDEND ) ;
system(command) ;
tmpdata = loadtags( ['tmp.txt' num2str(runID)], REDUND, genomeinfo(:, 1), PAIREDEND, FORMAT) ;

if(FORMAT == 3)
datamod(:, i) = bintags(tmpdata, 10 , chrominfo, chromMap, binsize) ;
  else
datamod(:, i)  = bintags(tmpdata, 2 , chrominfo, chromMap, binsize) ;
  end
 bintags(tmpdata, 2 , chrominfo, chromMap, wsize) ;    

if(Icols > 1) 
    if (strcmp(INPUTfiles{i}, ':') == 0)    
command =  sprintf('tag2mat  %s tmp.txt%d genome-limits%d %d %d' ,CHIPfiles{i}, runID, runID, FORMAT, PAIREDEND ) ;
  system(command) ;
  tmpdata = loadtags( ['tmp.txt' num2str(runID)], REDUND, genomeinfo(:, 1), PAIREDEND, FORMAT) ;
  if(FORMAT == 3)
  data = bintags(tmpdata, 10 , chrominfo, chromMap, binsize) ;
  else
  data = bintags(tmpdata, 2 , chrominfo, chromMap, binsize) ;
  end
  
  controldataf = findtagdensity(data, binsize) ;
  clear data tmpdata ;
    else
        controldataf(:) = 0.2 ;
end
end

if(Icols > 0)
   datamod(:, i) = datamod(:, i) ./ (controldataf  + 0.5);
end
   
end

 scoremat = load(matrixFile) ;
 [rows sccols] = size(scoremat) ;
    [genes cols] = size(genedata) ;
   
    expr = [] ; 
    
    keeppos =  zeros(genes, 1 ) ;
    exprdata = zeros(genes, sccols ) ;
    lcollect = zeros(genes, 31) ;
    avgprom = zeros(genes, 1) ;
     
  [ rows  dcols ] = size(datamod)  
  
         for mark = 1:dcols
       count = 0 ;
             for i = 1:genes      
         minj = prommat(i,1) ; maxj = prommat(i, 2) ;
        
         if (genedata(i, 4) == 1)
         prominj = minj - 10 ; promaxj = minj + 20 ;
           if ((prominj > 0) & (promaxj < rows))
          count = count + 1 ;
          lcollect(count , :) = datamod(prominj:promaxj, 1) ; 
         exprdata(count , :) = scoremat(i , :) ;  
         keeppos(i) = 1 ;
           end
         else
             prominj = maxj - 20 ; promaxj = maxj + 10 ;
        if ((prominj > 0) & (promaxj < rows))
          count = count + 1 ;
        ctemp = datamod(prominj:promaxj, 1) ;
       lcollect(count , :) = ctemp((32 -(1:31))) ;
           exprdata(count , :) = scoremat(i , :)   ;  
           keeppos(i) = 1 ;
        end
        
         end
            
             end
             
       pcollect{mark} = lcollect(1:count,:) ;
       pavgprom(:,mark) = mean(lcollect(1:count,:), 2) ;
         end
         
         
         if(count < genes)
             exprdata(count+1:genes,:) = [] ;
         end
size(exprdata) 
size(pavgprom)

   
for i = 1:5
    tgdata = exprdata(:, 7*(i-1) + 1 : 7*i) ; 
expr(:, i) = log(tgdata(:, 1) + 1) ; 
resid(:, i) = tgdata(:, 2) ;

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%% old code %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   [ ronum conum] = size(ChIPnum) ;
%for i = 1:5
% tavgprom{i} = tgdata(:, (2+ChIPnum)) ;
% end


% for i = 1:5
%     for j = 1:dcols
%         ccrel(i, j) = corr(pavgprom(:, j) , tavgprom{i}(:, j) );
%     end
% [mi ridx ] = max( mean(ccrel)) ;
%     [ cer cidx ] = sort( ccrel( ridx, :) , 'descend') ;
% end
% 
% ridx 
% cidx 

% allc1 = allcol{tra} ;
% allc2 = allcol{lea} ;
% exprt = allexpr{tra} ;
% exprl = allexpr{lea} ;
% marks = 1:4 ; marks(lea) = [] ;
% %resid =  [ allresid{marks(1)} allresid{marks(2)} allresid{marks(3)} ];
% %resid =  [ allresid{marks(1)} allresid{marks(2)} ] ;
%      resid = allresid{tra} ;

%%%% find Rank invariant genes
 
% data =  tavgprom{ridx}(:, cidx(1)) ; [B idx] = sort( data ) ; rdata1(idx, 1) = 1:count ;
% data =   tavgprom{ridx}(:, cidx(2)) ; [B idx] = sort( data) ; rdata1(idx, 2) = 1:count ;
%     
% 
% data = mean(pcollect{cidx(1)} , 2) ; [B idx] = sort(data ) ; rdata2(idx, 1) = 1:count ;
%  data = mean(pcollect{cidx(2)} , 2) ; [B idx] = sort( data) ; rdata2(idx, 2) = 1:count ;
% 
%      pos = find(( abs(rdata1(:, 1) - rdata2(:, 1)) < 2000 ) & ( abs(rdata1(:, 2) - rdata2(:, 2)) < 2000 ) ) ;
 %[rog cog] = size(pos) ;   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  

X = pcollect{1}  ; 
    
    for i = 2:ccols
    X = [ X pcollect{i} ] ;
    end


for i  = 1:5
Y = expr(: , i)  ;
[rog cog] = size(Y) ;
 newcov = optimiseCov(X' * X , 2, rog) ; beta = Y' * X * inv(newcov) ; Yp = beta * X'  ; Yp = Yp' ; 
corrs(i) = corr(Yp , Y) ;
pexpr(:, i) = Yp ;
end
[ma ridx] = max(corrs) ;

[B idx] = sort( pexpr(:,ridx) ) ; rdata1(idx, 1) = 1:count ;
[B idx] = sort(expr(:, ridx) ) ; rdata2(idx, 1) = 1:count ;


pos = find(abs(rdata1(:, 1) - rdata2(:, 1)) < 2000   ) ;


    [rog cog] = size(pos) ;
    
    Y = expr(pos , ridx)  ;
    X = pcollect{1}  ; 
    
    for i = 2:ccols
    X = [ X pcollect{i} ] ;
    end
    
    X =  log( X + 1)  ;

    if(NOcorrect == 0)
    X = [ 3*resid X ] ; 
    end
    
    Xt = X(pos,:) ;
    newcov = optimiseCov(Xt' * Xt , 2, rog) ; beta = Y' * Xt * inv(newcov) ; Yp = beta * X'  ; Yp = Yp' ;
   

 corr(Yp, expr(:,1))
 corr(Yp, expr(:,2))
 corr(Yp, expr(:,3))
 corr(Yp, expr(:,4))
 corr(Yp, expr(:,5))



kpos = find(keeppos == 1) ;

fid = fopen( outfile, 'w') ;
fprintf(fid , 'RefSeq-ID\tchromosome\tsign\tgene-start\tgene-end\tGene-name\tlog(predicted_expression)\n') ;
for i = 1:count
if(sign(kpos(i)) == 1)    
fprintf(fid, '%s\t%s\t+\t%d\t%d\t%s\t%f\n' , NMlist{kpos(i)}, chrom{kpos(i)}, cdst(kpos(i)), cdend(kpos(i)), gname{kpos(i)}, Yp(i) ) ;
else
  fprintf(fid, '%s\t%s\t-\t%d\t%d\t%s\t%f\n' , NMlist{kpos(i)}, chrom{kpos(i)}, cdst(kpos(i)), cdend(kpos(i)), gname{kpos(i)}, Yp(i) ) ;  
end
end
fclose(fid) ;

command = [ 'rm genome-limits'  num2str(runID) ' tmp.txt' num2str(runID) ] ;
system(command) ;


%%%%%%%%%%%%%
%  1-H3K27ac , 2-H4K20m1, 3-H3K4me3, 4-H3K36me3, 5-H3K9ac
%
%
%
%    


