function newcov = optimiseCov(covr, model, N)

%[rows N] = size(X) ;
%covr = cov(X') ;
%N = 10000 ;
[rows cols] = size(covr) ;

[V,D] = eig(covr) ;

for i = 1:rows
    Ei(i) = abs(D(i, i)) ;
end

[B idx] = sort(Ei, 'descend') ;
cost = zeros([rows, 1]) ;

if( model == 1)

for k = 1:rows
    cost(k) =  ((rows - k)*N)* (  log( sum(Ei(idx(k+1:rows))) / (rows-k) )  - sum(log(Ei(idx(k+1:rows)))) / (rows -k) ) ;
    cost(k) = cost(k) +  0.5*(k*(2*rows -k )) *log(N) ;
end
end


if( model == 2)

for k = 1:rows
    cost(k) =  ((rows - k)*N)* (  log( sum(Ei(idx(k+1:rows))) / (rows-k) )  - sum(log(Ei(idx(k+1:rows)))) / (rows -k) ) ;
    cost(k) = cost(k) +  (k*(2*rows -k )) *sqrt(N*log(N)) ;
end
end

if( model == 3)

for k = 1:rows
    cost(k) =  ((rows - k)*N)* (  log( sum(Ei(idx(k+1:rows))) / (rows-k) )  - sum(log(Ei(idx(k+1:rows)))) / (rows -k) ) ;
    cost(k) = cost(k) +  (k*(2*rows -k )) *log(N) ;
end
end



if( model == 4)

for k = 1:rows
      cost(k) = ((rows - k)*N) *(  log( sum(Ei(idx(k+1:rows))) / (rows-k) )  - sum(log(Ei(idx(k+1:rows)))) / (rows -k) )  ;
    cost(k) = cost(k) +   (k*(2*rows -k))  ;
end
end

 
%figure, plot( cost)
[mi pos] = min(cost) ;
minD = Ei(idx(pos)) ;
[ pos minD]  

for i=1:rows
   if (abs(D(i,i)) < minD) 
   D(i,i) = minD ;
   end
end



newcov = V * D * inv(V) ;








