vartrack = zeros(6 ,1) ;

TFmode = 0;
mFoldSt = 2 ; 
Auto = 1 ;
Auton = 1 ;
taglength = 200 ;
peakmerge = 500 ;
 RefineMode = 0 ;
 selectPos = -1 ;
Ksize = 100 ;
binsize = 100 ;
direction = 0 ;
    INPUTfiles = {} ; 
    wigMode = 0 ;
 RESCUE = 0 ;
  autowidth = 1 ;  
truncateWidePeaks = 0 ;
NwigMode = 0 ; 
REDUND = 1 ;
PAIREDEND = 0 ;
FORMAT = 1 ;
SHIFT = 1 ;
LPVAL = 5 ;


for i = 1:optargin
checkt = textscan( cargs{i} , '%s' , 'delimiter' , '=') ;
  
if (strcmp( checkt{1}{1} , '-d' ) == 1)
  vals = textscan( checkt{1}{2}, '%s' , 'delimiter' , ',' ) ;  
    CHIPfiles = vals{1} 
    vartrack(1) = 1 ;
end

if (strcmp( checkt{1}{1} , '-c' ) == 1)
    vals = textscan( checkt{1}{2}, '%s' , 'delimiter' , ',' )  ;
    INPUTfiles = vals{1} 
    vartrack(2) = 1 ;
end

if (strcmp( checkt{1}{1} , '-o' ) == 1)
    OUTPUTfile =   checkt{1}{2} 
    vartrack(3) = 1 ;
end

if (strcmp( checkt{1}{1} , '-f' ) == 1)
    if( (strcmp(checkt{1}{2} , 'BAM') == 1) | (strcmp(checkt{1}{2} , 'SAM') == 1)  )  
    FORMAT = 2 ;
    end
     if( (strcmp(checkt{1}{2} , 'bam') == 1) | (strcmp(checkt{1}{2} , 'sam') == 1)  )
     FORMAT = 2 ;
     end    
    if( (strcmp(checkt{1}{2} , 'bedgraph') == 1) |(strcmp(checkt{1}{2} , 'bedGraph') == 1)) 
    FORMAT = 3;
    end
end


if (( strcmp( checkt{1}{1} , '-nonzero' ) == 1) | ( strcmp( checkt{1}{1} , '-NONZERO' ) == 1))
    TFmode = 1  ; 
    vartrack(4) = 1 ;
end

if (( strcmp( checkt{1}{1} , '-dir' ) == 1) | ( strcmp( checkt{1}{1} , '-DIR' ) == 1))
   direction = 1;
end

if ( strcmp( checkt{1}{1} , '-pe' ) == 1) 
    PAIREDEND = 1 ;
end

if (strcmp( checkt{1}{1} , '-bs' ) == 1)
       tempd =  textscan(checkt{1}{2} , '%f')  ;
    binsize = tempd{1} ;
       vartrack(5) = 1 ;
end

if (strcmp( checkt{1}{1} , '-ks' ) == 1)
       tempd =  textscan(checkt{1}{2} , '%f')  ;
    Ksize = tempd{1} 
       vartrack(6) = 1 ;
       autowidth = 0 ;
end

if (strcmp( checkt{1}{1} , '-lpval' ) == 1)
       tempd =  textscan(checkt{1}{2} , '%f')  ;
    LPVAL = tempd{1} ; 
       
end


if (strcmp( checkt{1}{1} , '-redund' ) == 1)
       tempd =  textscan(checkt{1}{2} , '%d')  ;
    REDUND = tempd{1} ;      
end


if (strcmp( checkt{1}{1} , '-pos' ) == 1)
       PositiveBed = checkt{1}{2} ;
       vartrack(7) = 1 ;
       Auto = 0 ;
end

if (strcmp( checkt{1}{1} , '-rescue' ) == 1)
       RESCUE = 1;
end


if (strcmp( checkt{1}{1} , '-tw' ) == 1)
       tempd =  textscan(checkt{1}{2} , '%d')  ;
    truncateWidePeaks  = tempd{1}        
end

if (strcmp( checkt{1}{1} , '-tagsize' ) == 1)
    if(strcmp(checkt{1}{2} , 'auto') == 1 )
    SHIFT = 0 ;
    else
       tempd =  textscan(checkt{1}{2} , '%d')  ;
    taglength = tempd{1} ; 
    if((taglength < 40) | (taglength > 800)) 
    printf('check the taglength. It does not seem genuine\n setting taglength = 200bp ') ;
    taglength = 200 ;
    end
    end
end


if (strcmp( checkt{1}{1} , '-pm' ) == 1)
       tempd =  textscan(checkt{1}{2} , '%d')  ;
    peakmerge  = tempd{1}        
end

if (strcmp( checkt{1}{1} , '-refine' ) == 1)
    RefineMode = 1 
end

if (strcmp( checkt{1}{1} , '-wig' ) == 1)
    wigMode = 1 
end

if (strcmp( checkt{1}{1} , '-nwig' ) == 1)
    NwigMode = 1 
end


end

% 
% if(Auto == 1)
% Type = 'any' ;                            % For Transcription fractor CHiPseq use Type = 'any'
% else
% PositiveBed = 'Prompos1.bed'  % change it to the bed file name which contains postives locations
% end
% 
% if(Auton == 0)
% NegativeBed = 'negatives.bed' 
% end




disptext = { 
'-d=ChIPfiles   filenames of sample, containing tags from high throughput sequencing.'
'                More than one filename can be given. The files can be in 6-column bed' 
'               format,bam, sam or bedGraph format.' 
'             '

'-c=INPUTfiles   filenames of control input tags, more than one filename is given. same format as ChIPfile'
'                if more than one input control file is given then it should be equal to number of sample filename. (optional)'
'                  '

'-o=OUPUTfile    single filename to save predicted regions (compulsory)'
'            '

'-lpval=value    a number to decide -log10(P-value) threshold to detect region after calculating scores'
'               Default is 5 it means (P-value=1E-5 is threshold). Check tutorial for threshold for different assays'
'            '

'-f=bam/sam/bed/bedgraph    the format of input either it is bam, sam,bedGraph or bed (6 column bed file)'
'                  default input is assumed to be in bed format' 
'            '

'-pos=bedFile    the name of 3 column bed file containing set of positives (optional)'
'                 ' 

'-bs=basepair    bin size in form of base pair, default=100 basepairs (optional)'
'               '

'-ks=kernel_size    size of kernel in form of bins. default=100 bin '
'               '
'-wig     to save wiggle track of raw signal and filtered signal, resolution same as binsize'
'                   '

'-nonzero          to use kernels with non-zero mean (optional), by default it uses zero mean kernel'
'                  for pattern recognition, non-zero mean kernel is good for ' 
'                  transcription factors ChIP-seq or signals with variable width like H3K27me3'
'                     '

'-pe    if the tags are paired end. For paired end read provide BAM/SAM file with tags sorted by name'
'              '               

'-tagsize=basepair   the size of tags in basepairs. Default is 200bp. for automatic finding of tagsize use "-tagsize=auto"'
'                  '

'-refine    to refine the center of detected region'
'                '


'-tw=basepairs   truncate wider peaks which are more wide than given basepair width. (optional)'
'                '

'-redund=N   N is the number of tags allowed with same orientation and location Default=1 '
'              '

'-pm=basepairs    merges the regions which are closer than given basepair distance. (optional)' 
'                     '
'-dir    to run dfilter taking directionality of regultory site such as promoters '

} ;





if( (vartrack(1) == 0 ) | (vartrack(3) == 0 ) )
fprintf('%s\n', disptext{:}) ;
end

if(vartrack(1) == 0 )
   errors = 'No sample data file given    exiting ' ;
   
   exit(1) ; 
end

if(vartrack(2) == 0 )
   warning = 'No input control file given     going to run without control '
    
end

if(vartrack(3) == 0 )
   errors = 'No output file name given   exiting  \n' ; 
   exit(1) ; 
end

if ((vartrack(5) == 0) & (TFmode == 1))
    binsize = 50 
end

if ((vartrack(6) == 0) & (TFmode == 1))
    Ksize = floor(2000 /binsize) ; 
end















