function refine1( CHIPfiles, INPUTfiles , peaks  ,OUTPUTfile , binsize, runID, FORMAT, PAIREDEND )

[OUTFILEpath, OUTFILEname, OUTFILEext] = fileparts(OUTPUTfile) ;
if( strcmp(OUTFILEpath, '') == 1)
    OUTFILEpath = './' 
end


winwidth = 1000 ;
Kwidth = 200 ;

% [pchr plocs ploce pscore pmid ] = textread(PEAKfile, '%s\t%d\t%d\t%f\t%d') ;
% 
% [prows cols] = size(plocs) ;
% peaks = zeros([prows cols]) ;
% 
% for i = 1:prows
%     ltext = textscan(pchr{i} , '%s') ;
%     chrname = ltext{1}{1} ;
%     
%  if(strcmp(chrname , 'chrX') == 1)      
%      chrname = chrX ;   end
%  if(strcmp(chrname , 'chrY') == 1) 
%      chrname = chrY ; end
%  if(strcmp(chrname , 'chrM') == 1) 
%      chrname = chrM ; end
%  
%  chr  = textscan( chrname, '%s %d', 'delimiter' , 'r') ;
%  
%  peaks(i, 1) = chr{2} ; 
% end
%peaks(:, 2:5) = [ plocs ploce pscore pmid ] ;

 [prows cols] = size(peaks) ;
[B idx] = sort(peaks(:, 4), 'descend') ;
peaks = peaks(idx, :) ;
 
 

[actualChr actualLow actualHigh] = textread(['genome-limits' num2str(runID) ] , '%s %d %d') ;
[chromcount cols] = size(actualLow) ;
genomeinfo(:, 1) = (1:chromcount)' ;
genomeinfo(:, 2) = actualLow;
genomeinfo(:, 3) = actualHigh;
[chromcount cols] = size(genomeinfo) ;

locs = 0 ;
taglength = 200 ;

 shift = ceil(taglength / (2*binsize)) ;

 %%%%%  arrange chromsomes binning and limits info %%%%%%%%%%%%%%%%
chromMap = [] ; locs = 0 ;
for i =1:chromcount
chrominfo(i, 1) = genomeinfo(i, 1) ;
chromMap(genomeinfo(i, 1), 1) = i ;
chrominfo(i, 2) = locs + 1 ;
chrominfo(i, 3) = genomeinfo(i, 2) ;
locs = locs + ( genomeinfo(i, 3) - genomeinfo(i, 2)) / binsize ;
chrominfo(i, 4) = locs ; 
chrominfo(i, 5) = genomeinfo(i, 3) ;
end

chrominfo = ceil(chrominfo) ;
totalbins = chrominfo(chromcount, 4) ;

command =  sprintf('tag2mat  %s tmp.txt%d genome-limits%d %d %d' ,CHIPfiles{1}, runID, runID, FORMAT, PAIREDEND ) ;
   system(command) ;
   tmpdata = loadtags( ['tmp.txt' num2str(runID)], 1, genomeinfo(:, 1), PAIREDEND, FORMAT) ;
 %  tmpdata = ceil(tmpdata) ;


[csize ccol] = size(chromMap) ;
[ prows pcols ] = size(peaks) ;

bingap = ceil(winwidth / binsize)  
bingap2 = 2*bingap ;
%tagsNeg = zeros(prows, bingap2 ) ;
%tagsPos = zeros(prows, bingap2 ) ;

 [ tagsPos tagsNeg] = tagto2D1( tmpdata , peaks , chrominfo , chromMap, binsize, bingap, 0 ) ;
 clear tmpdata ;
 
 [Iro Icols] = size(INPUTfiles) ;
 if(Icols > 0)
      command =  sprintf('tag2mat  %s tmp.txt%d genome-limits%d %d %d' ,INPUTfiles{1}, runID, runID, FORMAT, PAIREDEND ) ;
   system(command) ;
   ctmpdata = loadtags( ['tmp.txt' num2str(runID)], 1, genomeinfo(:, 1), PAIREDEND, FORMAT) ;
     meanwin = ones(ceil(1000/binsize) , 1) ; meanwin = meanwin/ sum(meanwin) ;
[ctagsPos ctagsNeg] = tagto2D( ctmpdata , peaks , chrominfo , chromMap, binsize, bingap ,1 ) ;
ctagsAll = ctagsPos ;

for i = 1:prows
ctagsAll = convn( (ctagsPos(i,:) + ctagsNeg(i, :)) , meanwin, 'same' ) ;
tagsPos(i, :) = tagsPos(i, :)./ (ctagsAll + 0.3);
tagsNeg(i, :) = tagsNeg(i, :)./ (ctagsAll + 0.3);
end
 clear ctagsPos ctagsNeg  ctmpdata ;
 end
 
 ksize = ceil(Kwidth / binsize) 

%    sigma = 0.25*(taglength /binsize)
%   skernel = ones(1, 2*ksize +1) ; skernel= skernel / sum( skernel) ;
%   for  i = -ksize:ksize
%       skernel(i+ksize +1) = exp(-i *i /(sigma *sigma) ) ;
%   end
% % 

  lkcount = prows ; 
  
  if(lkcount > 2000)
      lkcount = 2000 ;
  end
  
  
%  tagsPos(1:10,:)
% tagNeg(1:10,:)
  
     kcount = 0 ;
     pkernel = zeros( 1 , 2*ksize +1 ) ;
     nkernel = zeros( 1 , 2*ksize +1 ) ;
     for i = 1:lkcount
     pkernel = pkernel + tagsPos(i, (bingap - ksize) : (bingap +  ksize) ) ;
     nkernel = nkernel + tagsNeg(i, (bingap - ksize) : (bingap +  ksize) ) ;
     end
   pkernel = pkernel / lkcount ; nkernel = nkernel / lkcount ;
  
  [ma pmaxloc] = max(pkernel)  
  [ma nmaxloc] = max(nkernel)  
  
  shift2 = nmaxloc - pmaxloc   ;
  if(shift2 < 1)  
      shift2 = ceil(taglength / binsize) ;
  end
  
    shift = ceil(shift2 /2) ;  
      
    lcollect = zeros( lkcount , 2*ksize +1 ) ;
    lcollectn = zeros( lkcount , 2*ksize +1 ) ;
    
   
      for i = 1:lkcount
      lcollect(i,:) = tagsPos(i, (bingap - ksize -shift) : (bingap +  ksize- shift) ) ;
      end
         
      comprofile = mean( lcollect) ;
      covar = (lcollect' * lcollect / lkcount) - comprofile' * comprofile ;
 
  invcov = optimiseCov(covar , 2 , lkcount ) ;
  pkernel = (inv(invcov) * comprofile')' ; 
  size(pkernel) ;
  pkernel = pkernel/ max(pkernel) ;
  nkernel = pkernel ;
  
   for i= 1:2*ksize +1 
       nkernel(i) = pkernel( 2*ksize + 2  -i) ;
   end
      
 skernel = (pkernel + nkernel)/ 2; 
 % skernel = skernel - min(skernel) ;
 %[pkernel nkernel]
%  plot( pkernel) ; hold on, plot(nkernel, 'r') ; plot(skernel, 'c') 
  
shift2 = 2*shift ;
avgshift = 0 ;

for i = 1:prows
 tagsPos(i,:) = convn(tagsPos(i,:), pkernel , 'same') ; 
%[ma maloc1] = max(tagsPos(i, : ) ) ;
 tagsNeg(i,:) = convn(tagsNeg(i,:), nkernel , 'same') ; 
%[ma maloc2] = max(tagsNeg(i, : ) )  ;
%avgshift = avgshift + abs( maloc2 - maloc1) ;

% if(i < 5)
% figure, plot(tagsPos(i,:), 'b'); hold on ; plot(tagsNeg(i,:), 'r')
% end

end

avgshift = shift2 ;
avgshifth =  shift ;
 bingap2
 avgshifth 
for i = 1:prows
 tmtAll(avgshifth :bingap2 - avgshifth) = tagsPos(i, 1: bingap2-avgshift+1) + tagsNeg(i, avgshift: bingap2) ; 
% tmtAll = tagsPos(i, :) + tagsNeg(i, :) ;
 
 [ma maLoc] = max(tmtAll(bingap - 30 : bingap + 30 ) ) ;
peaks(i, 5) = peaks(i, 5) - winwidth + ( bingap - 31 + maLoc ) * binsize ;
end

instr= 'chromosome  peak-start   peak-end   maxScore    peak-center     -log10(P-value)     Norm-tag-count   FDR(%)' ;
writebedNew(peaks, OUTPUTfile, actualChr, instr) ;

instr= ['track name="DFilter-peaks' OUTPUTfile '"' ] ;
peaktrackfile = [OUTFILEpath '/track-' OUTFILEname '.bed' ] ;
writebedNew(peaks(:, 1:4), peaktrackfile, actualChr, instr) ;




