function [ tagsPos tagsNeg] = tagto2D1( tmpdata , peaks , chrominfo , chromMap, binsize, bingap, typin )
shift = ceil(200 /(2*binsize)) ;
[ro col] = size(tmpdata) ;
[ prows pcols ] = size(peaks) 
[csize cols] = size( chrominfo) ;
bingap2 = 2*bingap+1 ;

tagsPos = zeros(prows, bingap2 ) ;
tagsNeg = zeros(prows, bingap2 ) ;

[ chromcount cols ] = size(chromMap) ;

chrominfo
for chrm = 1:chromcount
    
    chr = chromMap(chrm,1) ;
    pospe = find(peaks(:, 1) == chr) ;
    postg = find((tmpdata(:, 1) == chrm ) & (tmpdata(:, 3) == 1 ) & (tmpdata(:, 2) > chrominfo(chr, 3) ) & (tmpdata(:, 2) < chrominfo(chr, 5))) ;
    ctagpos = ceil((tmpdata(postg, 2) - chrominfo(chr, 3)) / binsize)  ;
   clear temploc ;
    
   temploc(:, 1) =  ceil((peaks(pospe, 5) - chrominfo(chr, 3)) / binsize) - bingap  ;
   temploc(:, 2) =  ceil((peaks(pospe, 5) - chrominfo(chr, 3)) / binsize) + bingap  ;
    
   pos = find(temploc(:,1) < 1) ; temploc(pos,1) = 1 ;
   pos = find(temploc(:,2) > (chrominfo(chr,4) - chrominfo(chr,2)) ) ;
   temploc(pos,2) = chrominfo(chr,4) - chrominfo(chr,2) ; 
 
    locarray = zeros((chrominfo(chr,4) - chrominfo(chr,2) +100), 1) ;
    
    [trows tcols] = size(postg) ;
    [perows pecols] = size(pospe) ;
    
   
    for i = 1:trows
        locarray( ctagpos(i), 1) = locarray(ctagpos(i), 1 ) + 1 ;
    end
    
    
    
    for i = 1:perows
if( ( temploc(i,2) - temploc(i, 1) + 1) == bingap2 )
    tagsPos(pospe(i), :) = (locarray( temploc(i,1) : temploc(i, 2) , 1 ))'  ;  
end
    end
    
    
    postg = find((tmpdata(:, 1) == chrm ) & (tmpdata(:, 3) == -1 ) & (tmpdata(:, 2) > chrominfo(chr, 3) ) & (tmpdata(:, 2) < chrominfo(chr, 5))) ;
   ctagpos =  ceil((tmpdata(postg, 2) - chrominfo(chr, 3)) / binsize)  ;
  
    [trows tcols] = size(postg) ;
    locarray = zeros(chrominfo(chr,4) - chrominfo(chr,2) + 100, 1) ;
    for i = 1:trows
        locarray( ctagpos(i) , 1) = locarray(ctagpos(i), 1 ) + 1 ;
    end
    
    for i = 1:perows
if( ( temploc(i,2) - temploc(i, 1) + 1) == bingap2 )
    tagsNeg(pospe(i), :) = (locarray( temploc(i,1) : temploc(i, 2) , 1 ))'  ;  
end
    end
    

end


%tagNeg(1:10,:)

clear locarray temploc pospe postg ;










% 
% for i = 1:ro
%     chrname = tmpdata(i , 1) ;   
% if((chrname <= csize ) & (chrname > 0 ))
%     chr = chromMap(chrname,1) ;
%     ploc1 = tmpdata(i , 2) ; 
%     
%      chrloc1 = chrominfo(chr, 2) + ceil((ploc1 - chrominfo(chr, 3)) / binsize)  ;    
%     tmpdata(i, 2) = chrloc1 ;
%     tmpdata(i, 1) = chr ;
% end
% 
% end
% 
% 
% 
% 
%  
% 
% prvchr = 0 ;
% for i = 1:prows
%     chrname = peaks(i, 1) ;   
% 
%   if((chrname <= csize ) & (chrname > 0 ))
%     chr = chromMap(chrname,1) ;
%     ploc1 = peaks(i , 5) ;
%   
%      chrloc1 = chrominfo(chr, 2) + ceil((ploc1 - chrominfo(chr, 3)) / binsize) - bingap ;
% 
% if(prvchr == chr)  
%     pos1 = find( ((tmpdata(posch, 2) - chrloc1) <  bingap2) & ((tmpdata(posch, 2) - chrloc1) > shift) ) ;
% posp = posch(pos1) ;
% else
% posch = find(tmpdata(:, 1) == chr) ;
%  pos1 = find( ((tmpdata(posch, 2) - chrloc1) <  bingap2) & ((tmpdata(posch, 2) - chrloc1) > shift) ) ;
% posp = posch(pos1) ;
% prvchr = chr ;
% end
% 
% [ppro cols ] = size(posp) ;
% 
%        if(typin == 0) 
%         for j = 1:ppro
%             dloc = tmpdata(posp(j), 2) - chrloc1  ;
%         if(tmpdata(posp(j), 3) == 1 )     
%           tagsPos(i , dloc ) = tagsPos(i , dloc ) + 1 ;  
%         else
%           tagsNeg(i , dloc ) = tagsNeg(i , dloc ) + 1 ;       
%         end
%         
%         end
%        else 
%             for j = 1:ppro
%           dloc = tmpdata(posp(j), 2) - chrloc1 ; 
%         if(tmpdata(posp(j), 3) == 1 )     
%           tagsPos(i , dloc:dloc+shift ) = tagsPos(i , dloc:dloc+shift ) + 1 ;  
%         else
%           tagsNeg(i ,dloc-shift:dloc ) = tagsNeg(i , dloc-shift:dloc ) + 1 ;       
%         end
%             end          
%        end
% 
%        
% end
% 
% end
% end
% 
% 
% 
% 
